Unit GSP1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, GSU1R_p, UTGS10_p;

procedure GSP1R(RLAM :Real; var ISEED :Integer; N :Integer;
                var K :Array of Integer; var IERR :Integer);

implementation

procedure GSP1R(RLAM :Real; var ISEED :Integer; N :Integer;
                var K :Array of Integer; var IERR :Integer);
var
I :Integer;
Z,T :Real;
R :Array [0..0] of Real;
label
_1,_2,_3,_4,_5;
begin
IERR := 0;
if ( RLAM > 0.0 ) and ( RLAM < 40.0 ) 
 then goto _1;
IERR := 65;
goto _4;
_1:
Z := Exp(-RLAM);
for I:=1 to N do
 begin
  T := 1.0;
  K[I-1] := 0;
_2:
  GSU1R(ISEED,1,R[0]);
  T := T*R[0];
  if ( T <= Z ) 
   then goto _3;
  K[I-1] := K[I-1]+1;
  goto _2;
_3:
 end;
goto _5;
_4:
UTGS10(IERR,1);
_5:
end;

end.
